﻿using System;
using System.CodeDom;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static System.Windows.Forms.VisualStyles.VisualStyleElement.ListView;


namespace _02_dat_winform
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        //Data Source=(LocalDB)\MSSQLLocalDB;AttachDbFilename="C:\Users\unixu\Documents\spsostrov-individualni-vzdelavaci-plan-ctvrty-rocnik-i4-od-1.9.2023\pgv\opakovani od 3.9.2024\02-dat-winform\02-dat-winform\Database1.mdf";Integrated Security=True
        //Data Source=(LocalDB)\MSSQLLocalDB;AttachDbFilename='|DataDirectory|Database1.mdf';Integrated Security=True";
        String connectionString = @"Data Source=(LocalDB)\MSSQLLocalDB;AttachDbFilename='|DataDirectory|Database1.mdf';Integrated Security=True";

        private void Form1_Load(object sender, EventArgs e)
        {
            saveFileDialog1.Filter = "Csv Files (*.csv)|*.csv";
        }

        List<string> dataList = new List<string>();

        //Filter="*.exe|exe|";
        private void button1_Click(object sender, EventArgs e)
        {
            //LOAD TABLE FROM DATABASE
            LoadDatabase();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            //BACKUP LOADED TABLE FROM DATABASE TO CSV FILE
            BackupDatabase();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            //LOAD BACKUP DATA FROM CSV FILE 
             LoadBackup();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            //ERASE TABLE FROM DATABASE
            EraseTable();

        }

        private void button5_Click(object sender, EventArgs e)
        {
            //INSERT LOADED DATA FROM CSV INTO TABLE
            InsertLoadedDataFromCSVFile();

        }


        private void button9_Click(object sender, EventArgs e)
        {
            //INSERT
            //INSERT DATA TO TABLE FROM TEXTBOXES WHERE ID
            void InsertDataIntoTable()
            {

            }
        }

        private void button8_Click(object sender, EventArgs e)
        {
            //UPDATE
            //UPDATE DATA IN TABLE FROM TEXTBOXES BY ID
            void UpdateDataInTable(){
            }

        }


        private void button10_Click(object sender, EventArgs e)
        {
            //DELETE
            //DELETE DATA IN TABLE BY TEXTBOX ID
            void DeleteDataInTable()
            {

            }
        }





        private void button7_Click(object sender, EventArgs e)
        {
            //About
            MessageBox.Show("Databáze V3 MS-SQL LOCALDB, David Tomek I4 25.9.2024 https://home.spsostrov.cz/~tomeda/, unixuser@seznam.cz");
        }

        private void button6_Click(object sender, EventArgs e)
        {   //Close
            Close();
        }


     

        void LoadDatabase()
        {
            //LOAD TABLE FROM DATABASE
            listBox1.Items.Clear();
            dataList.Clear();
            //listBox1.Items.Add("ID\tFirstName\tLastName\tAge\tEmai\tAddress\tPhone\tJob");
            dataList.Add("ID\tFirstName\tLastName\tAge\tEmai\tAddress\tPhone\tJob");

            string dotaz = "SELECT * FROM Osoby";
            SqlConnection spojeni = new SqlConnection(connectionString);
            spojeni.Open();
            ; SqlCommand prikaz = new SqlCommand(dotaz, spojeni);
            SqlDataReader dataReader = prikaz.ExecuteReader();
            //string data = "";
            int i = 0;
            string[] vstup = null;
            string radka = null;
            while (dataReader.Read())
            {
                //data += dataReader[i] + "\t";
                //i++;

                //listBox1.Items.Add(dataReader[0] + "\t" + dataReader[1] + "\t" + dataReader[2] + "\t" + dataReader[3] + "\t" + dataReader[4] + "\t" + dataReader[5] + "\t" +
                //dataReader[6] + "\t" + dataReader[7]);
                dataList.Add(dataReader[0] + "\t" + dataReader[1] + "\t" + dataReader[2] + "\t" + dataReader[3] + "\t" + dataReader[4] + "\t" + dataReader[5] + "\t" +
                dataReader[6] + "\t" + dataReader[7]);
            }

            foreach (string s in dataList)
            {
                vstup = s.Split('\t');
                for (int j = 0; j < vstup.Length; j++)
                {
                    vstup[j] = vstup[j].Trim();
                }
                radka = String.Join("\t", vstup);
                listBox1.Items.Add(radka);
            }
            //listBox1.Items.Add(dataReader[0] + "\t" + dataReader[1] + "\t" + dataReader[2] + "\t" + dataReader[3] + "\t" + dataReader[4] + "\t" + dataReader[5] + "\t" +
            //dataReader[6] + "\t" + dataReader[7]);
        }

        void BackupDatabase()
        {
            //BACKUP LOADED TABLE FROM DATABASE TO CSV FILE
            string[] dataS;
            string dataS2;

            DialogResult vysledek = saveFileDialog1.ShowDialog();
            if (vysledek == DialogResult.OK)
            {
                StreamWriter soubor = new StreamWriter(saveFileDialog1.FileName);
                foreach (string data in dataList)
                {
                    dataS = data.Split('\t');

                    for (int i = 0; i < dataS.Length; i++)
                    {
                        dataS[i] = dataS[i].Trim();
                    }

                    dataS2 = String.Join(";", dataS);
                    soubor.WriteLine(dataS2);
                }
                soubor.Close();
            }

        }

        void LoadBackup()
        {
            //LOAD BACKUP DATA FROM CSV FILE 
            listBox1.Items.Clear();
            dataList.Clear();
            DialogResult vysledek = openFileDialog1.ShowDialog();
            string radka = null;
            string[] vstup = null;
            string data = null;
            if (vysledek == DialogResult.OK)
            {
                StreamReader soubor = new StreamReader(openFileDialog1.FileName);
                while ((radka = soubor.ReadLine()) != null)
                {
                    vstup = radka.Split(';');
                    data = String.Join("\t", vstup);
                    listBox1.Items.Add(data);
                    dataList.Add(data);

                }
                soubor.Close();
            }
        }

        void EraseTable()
        {
            //ERASE TABLE FROM DATABASE
            string dotaz = "DELETE  FROM Osoby";
            SqlConnection spojeni = new SqlConnection(connectionString);
            spojeni.Open();
            SqlCommand prikaz = new SqlCommand(dotaz, spojeni);
            prikaz.ExecuteNonQuery();
            spojeni.Close();
        }

        void InsertLoadedDataFromCSVFile()
        {
            //INSERT LOADED DATA FROM CSV INTO TABLE
            string[] vstup = null;
            int index = 0;
            int Id = 0;
            string FirstName = null;
            string LastName = null;
            int Age = 0;
            string Email = null;
            string Address = null;
            int Phone = 0;
            string Job = null;


            SqlConnection spojeni2 = new SqlConnection(connectionString);
            spojeni2.Open();

            string dotaz2 = "SET IDENTITY_INSERT Osoby ON; " +
                 "INSERT INTO Osoby (Id, FirstName, LastName, Age, Email, Address, Phone, Job) VALUES  (@Id, @FirstName, @LastName, @Age, @Email, @Address, @Phone, @Job)" +
                 "SET IDENTITY_INSERT Osoby OFF; ";
            //string dotaz2 = "INSERT INTO Osoby (Id, FirstName, LastName, Age, Email, Address, Phone, Job) VALUES  (@Id, @FirstName, @LastName, @Age, @Email, @Address, @Phone, @Job)";


            foreach (string radka in dataList)
            {


                if (index >= 1)
                {
                    vstup = radka.Split('\t');
                    Id = int.Parse(vstup[0]);
                    FirstName = vstup[1];
                    LastName = vstup[2];
                    Age = int.Parse(vstup[3]);
                    Email = vstup[4];
                    Address = vstup[5];
                    Phone = int.Parse(vstup[6]);
                    Job = vstup[7];

                    //MessageBox.Show(vstup[7]);
                    SqlCommand prikaz2 = new SqlCommand(dotaz2, spojeni2);

                    prikaz2.Parameters.AddWithValue("@Id", Id);
                    prikaz2.Parameters.AddWithValue("@FirstName", FirstName);
                    prikaz2.Parameters.AddWithValue("@LastName", LastName);
                    prikaz2.Parameters.AddWithValue("@Age", Age);
                    prikaz2.Parameters.AddWithValue("@Email", Email);
                    prikaz2.Parameters.AddWithValue("@Address", Address);
                    prikaz2.Parameters.AddWithValue("@Phone", Phone);
                    prikaz2.Parameters.AddWithValue("@Job", Job);

                    prikaz2.ExecuteNonQuery();
                }
                else
                {
                    // MessageBox.Show(Id.ToString());

                }
                index++;
            }

            spojeni2.Close();
        }


       
            //INSERT
            //InsertDataIntoTable
            void InsertDataIntoTable()
            {


            }


            //UPDATE
            //UpdateDataInTable
            void UpdateDataInTable()
            {

            }


            //DELETE
            //DeleteDataInTable
            void DeleteDataInTable()
            {

            }

    }
    }
